/****************************************************************
Copyright (c) 1998 Sandro Sigala <ssigala@globalnet.it>.
All rights reserved.

Permission to use, copy, modify, and distribute this software
and its documentation for any purpose and without fee is hereby
granted, provided that the above copyright notice appear in all
copies and that both that the copyright notice and this
permission notice and warranty disclaimer appear in supporting
documentation, and that the name of the author not be used in
advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

The author disclaim all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall the author be liable for any
special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
****************************************************************/

#ifndef KREPTON_H
#define KREPTON_H

#include <qlist.h>

enum SpriteObj {
	// Original Repton objects.  DO NOT CHANGE THE ORDER!

	Obj_Rock,
	Obj_Diamond,
	Obj_Ground1,
	Obj_Ground2,
	Obj_Time,
	Obj_Skull,
	Obj_Empty,
	Obj_Wall,
	Obj_Wall_West,
	Obj_Wall_East,
	Obj_Wall_North,
	Obj_Wall_South,
	Obj_Wall_North_West,
	Obj_Wall_North_East,
	Obj_Wall_South_West,
	Obj_Wall_South_East,
	Obj_Filled_Wall,
	Obj_Filled_Wall_North_West,
	Obj_Filled_Wall_North_East,
	Obj_Filled_Wall_South_West,
	Obj_Filled_Wall_South_East,
	Obj_Wall_Mirror,
	Obj_Strongbox,
	Obj_Cage,
	Obj_Egg,
	Obj_Key,
	Obj_Plant,
	Obj_Bomb,
	Obj_Transport,
	Obj_Crown,
	Obj_Repton,
	Obj_Blip,
	Obj_Blip2,
	Obj_Monster,
	Obj_Monster2,
	Obj_Repton_Look_Left,
	Obj_Repton_Look_Right,
	Obj_Repton_Go_Right1,
	Obj_Repton_Go_Right2,
	Obj_Repton_Go_Right3,
	Obj_Repton_Go_Right4,
	Obj_Repton_Go_Left1,
	Obj_Repton_Go_Left2,
	Obj_Repton_Go_Left3,
	Obj_Repton_Go_Left4,
	Obj_Repton_Go_Up1,
	Obj_Repton_Go_Up2,
        Obj_Broken_Egg,               
	NUM_SPRITES,

	// Non sprites.

        Obj_Broken_Egg1,	// Broken egg at stage 1.
        Obj_Broken_Egg2,	// Broken egg at stage 2.
        Obj_Broken_Egg3,	// Broken egg at stage 3.
        Obj_Falling_Egg		// The egg is falling, so will break.
};

const int num_sprites = NUM_SPRITES;
const int sprite_width = 32;
const int sprite_height = 32;

enum Sound {
	Sound_Cage_Blip,
	Sound_Die,
	Sound_Broken_Egg,
	Sound_Got_Crown,
	Sound_Got_Diamond,
	Sound_Got_Key,
	Sound_Got_Time,
	Sound_Kill_Monster,
	Sound_Transport
};

struct Episode {
	bool global;
	QString name;
	QString filename;
	int new_game_id;
	int continue_game_id;
	int load_sprites_id;

	Episode(const QString& xname, const QString& xfilename)
		: name(xname), filename(xfilename) {}
};

void loadEpisodeList(QList<Episode>& l, bool global);
int countUserEpisodes();

#endif // !KREPTON_H
